Panda3D

- Main Page
- Packages
- Classes

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Types | Public Member Functions | Static Public Member Functions

# TextProperties Class Reference

This defines the set of visual properties that may be assigned to the individual characters of the text. More...

Inheritance diagram for TextProperties:

List of all members.

## Public Types
enum | Alignment { ALeft = 0, ARight = 1, ACenter = 2, ABoxedLeft = 3, ABoxedRight = 4, ABoxedCenter = 5 }
## Public Member Functions
| TextProperties ()
| TextProperties (TextProperties const copy)
| addProperties (TextProperties const other)
| Sets any properties that are explicitly specified in other on this object.
| clear ()
| Unsets all properties that have been specified so far, and resets the TextProperties structure to its initial empty state.
| clearAlign ()
| Restores the default alignment of the text.
| clearBin ()
| Removes the effect of a previous call to set_bin().
| clearDrawOrder ()
| clearFont ()
| Restores the default font to the text.
| clearGlyphScale ()
| clearGlyphShift ()
| clearIndent ()
| Removes the indent setting from the text.
| clearPreserveTrailingWhitespace ()
| clearShadow ()
| Specifies that a shadow will not be drawn behind the text.
| clearShadowColor ()
| Removes the shadow color specification.
| clearSlant ()
| clearSmallCaps ()
| clearSmallCapsScale ()
| clearTabWidth ()
| clearTextColor ()
| Removes the text color specification; the text will be colored whatever it was in the source font file.
| clearTextScale ()
| clearUnderscore ()
| clearUnderscoreHeight ()
| clearWordwrap ()
| Removes the wordwrap setting from the text.
Alignment | getAlign ()
string | getBin ()
| Returns the drawing bin set with set_bin(), or empty string if no bin has been set.
int | getDrawOrder ()
| Returns the drawing order set with set_draw_order().
TextFont | getFont ()
| Returns the font currently in use, if any.
float | getGlyphScale ()
| Returns the scale factor of each letter as specified by set_glyph_scale().
float | getGlyphShift ()
| Returns the vertical shift of each letter as specified by set_glyph_shift().
float | getIndent ()
bool | getPreserveTrailingWhitespace ()
| Returns the preserve_trailing_whitespace flag.
Vec2 | getShadow ()
| Returns the offset of the shadow as set by set_shadow().
VBase4 | getShadowColor ()
float | getSlant ()
| Returns the factor by which the text is specified to slant to the right.
bool | getSmallCaps ()
| Returns the small_caps flag.
float | getSmallCapsScale ()
| Returns the scale factor applied to lowercase letters from their uppercase equivalents, when the small_caps flag is in effect.
float | getTabWidth ()
| Returns the width set via set_tab_width().
VBase4 | getTextColor ()
float | getTextScale ()
| Returns the scale factor of the text as specified by set_text_scale().
bool | getUnderscore ()
| Returns the underscore flag.
float | getUnderscoreHeight ()
| Returns the vertical height of the underscore; see set_underscore_height().
float | getWordwrap ()
bool | hasAlign ()
bool | hasBin ()
| Returns true if an explicit drawing bin has been set via set_bin(), false otherwise.
bool | hasDrawOrder ()
bool | hasFont ()
bool | hasGlyphScale ()
bool | hasGlyphShift ()
bool | hasIndent ()
bool | hasPreserveTrailingWhitespace ()
bool | hasShadow ()
bool | hasShadowColor ()
bool | hasSlant ()
bool | hasSmallCaps ()
bool | hasSmallCapsScale ()
bool | hasTabWidth ()
bool | hasTextColor ()
bool | hasTextScale ()
bool | hasUnderscore ()
bool | hasUnderscoreHeight ()
bool | hasWordwrap ()
bool | isAnySpecified ()
| Returns true if any properties have been specified, false otherwise.
bool | operator!= (TextProperties const other)
TextProperties | operator= (TextProperties const copy)
bool | operator== (TextProperties const other)
| setAlign (Alignment align_type)
| Specifies the alignment of the text within its margins.
| setBin (string bin)
| Names the CullBin that the text geometry should be assigned to.
int | setDrawOrder (int draw_order)
| Sets the drawing order of text created by the TextNode.
| setFont (TextFont font)
| Sets the font that will be used when making text.
| setGlyphScale (float glyph_scale)
| Specifies the factor by which to scale each letter of the text as it is placed, in addition to any scales inherited from the node or from set_text_scale().
| setGlyphShift (float glyph_shift)
| Specifies a vertical amount to shift each letter of the text as it is placed.
| setIndent (float indent)
| Specifies the amount of extra space that is inserted before the first character of each line.
| setPreserveTrailingWhitespace (bool preserve_trailing_whitespace)
| Sets the preserve_trailing_whitespace flag.
| setShadow (float xoffset, float yoffset)
| Specifies that the text should be drawn with a shadow, by creating a second copy of the text and offsetting it slightly behind the first.
| setShadow (VBase2 const shadow_offset)
| Specifies that the text should be drawn with a shadow, by creating a second copy of the text and offsetting it slightly behind the first.
| setShadowColor (VBase4 const shadow_color)
| setShadowColor (float r, float g, float b, float a)
| setSlant (float slant)
| Specifies the factor by which the text slants to the right.
| setSmallCaps (bool small_caps)
| Sets the small_caps flag.
| setSmallCapsScale (float small_caps_scale)
| Sets the scale factor applied to lowercase letters from their uppercase equivalents, when the small_caps flag is in effect.
| setTabWidth (float tab_width)
| Sets the width of each tab stop, in screen units.
| setTextColor (float r, float g, float b, float a)
| setTextColor (VBase4 const text_color)
| setTextScale (float text_scale)
| Specifies the factor by which to scale the text, in addition to any scalings imposed by the node, as well as in addition to the glyph scale.
| setUnderscore (bool underscore)
| Sets the underscore flag.
| setUnderscoreHeight (float underscore_height)
| Specifies the vertical height of the underscore, relative to the text baseline.
| setWordwrap (float wordwrap)
| Sets the text up to automatically wordwrap when it exceeds the indicated width.
| write (ostream out)
| write (ostream out, int indent_level)
## Static Public Member Functions
static TypeHandle | getClassType ()
static TextFont | getDefaultFont ()
| Specifies the default font to be used for any TextNode whose font is uninitialized or NULL.
static | setDefaultFont (TextFont)
| Specifies the default font to be used for any TextNode whose font is uninitialized or NULL.

## Detailed Description

This defines the set of visual properties that may be assigned to the individual characters of the text.

(Properties which affect the overall block of text can only be specified on the TextNode directly).

Typically, there is just one set of properties on a given block of text, which is set directly on the TextNode (TextNode inherits from TextProperties). That makes all of the text within a particular block have the same appearance.

This separate class exists in order to implement multiple different kinds of text appearing within one block. The text string itself may reference a TextProperties structure by name using the \1 and \2 tokens embedded within the string; each nested TextProperties structure modifies the appearance of subsequent text within the block.

## Member Enumeration Documentation

enum Alignment

Enumerator:

  ALeft |
  ARight |
  ACenter |
  ABoxedLeft |
  ABoxedRight |
  ABoxedCenter |

## Constructor & Destructor Documentation

TextProperties | ( |  | ) |

TextProperties | ( | TextProperties const | copy | ) |

## Member Function Documentation

addProperties | ( | TextProperties const | other | ) |

Sets any properties that are explicitly specified in other on this object.

Leaves other properties unchanged.

clear | ( |  | ) |

Unsets all properties that have been specified so far, and resets the TextProperties structure to its initial empty state.

clearAlign | ( |  | ) |

Restores the default alignment of the text.

Reimplemented in TextNode.

clearBin | ( |  | ) |

Removes the effect of a previous call to set_bin().

Text will be drawn in whatever bin it would like to be drawn in, with no explicit ordering.

Reimplemented in TextNode.

clearDrawOrder | ( |  | ) |

Reimplemented in TextNode.

clearFont | ( |  | ) |

Restores the default font to the text.

Reimplemented in TextNode.

clearGlyphScale | ( |  | ) |

Reimplemented in TextNode.

clearGlyphShift | ( |  | ) |

Reimplemented in TextNode.

clearIndent | ( |  | ) |

Removes the indent setting from the text.

Text will be as wide as it is.

Reimplemented in TextNode.

clearPreserveTrailingWhitespace | ( |  | ) |

clearShadow | ( |  | ) |

Specifies that a shadow will not be drawn behind the text.

Reimplemented in TextNode.

clearShadowColor | ( |  | ) |

Removes the shadow color specification.

Reimplemented in TextNode.

clearSlant | ( |  | ) |

Reimplemented in TextNode.

clearSmallCaps | ( |  | ) |

Reimplemented in TextNode.

clearSmallCapsScale | ( |  | ) |

Reimplemented in TextNode.

clearTabWidth | ( |  | ) |

Reimplemented in TextNode.

clearTextColor | ( |  | ) |

Removes the text color specification; the text will be colored whatever it was in the source font file.

Reimplemented in TextNode.

clearTextScale | ( |  | ) |

clearUnderscore | ( |  | ) |

clearUnderscoreHeight | ( |  | ) |

clearWordwrap | ( |  | ) |

Removes the wordwrap setting from the text.

Text will be as wide as it is.

Reimplemented in TextNode.

Alignment getAlign | ( |  | ) |

string getBin | ( |  | ) |

Returns the drawing bin set with set_bin(), or empty string if no bin has been set.

static TypeHandle getClassType | ( |  | ) | `[static]`

Reimplemented in TextNode, FrameRateMeter, and SceneGraphAnalyzerMeter.

static TextFont getDefaultFont | ( |  | ) | `[static]`

Specifies the default font to be used for any TextNode whose font is uninitialized or NULL.

See set_font().

int getDrawOrder | ( |  | ) |

Returns the drawing order set with set_draw_order().

TextFont getFont | ( |  | ) |

Returns the font currently in use, if any.

If no font is in use, this returns the default font.

float getGlyphScale | ( |  | ) |

Returns the scale factor of each letter as specified by set_glyph_scale().

float getGlyphShift | ( |  | ) |

Returns the vertical shift of each letter as specified by set_glyph_shift().

float getIndent | ( |  | ) |

bool getPreserveTrailingWhitespace | ( |  | ) |

Returns the preserve_trailing_whitespace flag.

See set_preserve_trailing_whitespace().

Vec2 getShadow | ( |  | ) |

Returns the offset of the shadow as set by set_shadow().

It is an error to call this if has_shadow() is false.

VBase4 getShadowColor | ( |  | ) |

float getSlant | ( |  | ) |

Returns the factor by which the text is specified to slant to the right.

bool getSmallCaps | ( |  | ) |

Returns the small_caps flag.

See set_small_caps().

float getSmallCapsScale | ( |  | ) |

Returns the scale factor applied to lowercase letters from their uppercase equivalents, when the small_caps flag is in effect.

See set_small_caps() and set_small_caps_scale().

float getTabWidth | ( |  | ) |

Returns the width set via set_tab_width().

VBase4 getTextColor | ( |  | ) |

float getTextScale | ( |  | ) |

Returns the scale factor of the text as specified by set_text_scale().

bool getUnderscore | ( |  | ) |

Returns the underscore flag.

See set_underscore().

float getUnderscoreHeight | ( |  | ) |

Returns the vertical height of the underscore; see set_underscore_height().

float getWordwrap | ( |  | ) |

bool hasAlign | ( |  | ) |

bool hasBin | ( |  | ) |

Returns true if an explicit drawing bin has been set via set_bin(), false otherwise.

bool hasDrawOrder | ( |  | ) |

bool hasFont | ( |  | ) |

bool hasGlyphScale | ( |  | ) |

bool hasGlyphShift | ( |  | ) |

bool hasIndent | ( |  | ) |

bool hasPreserveTrailingWhitespace | ( |  | ) |

bool hasShadow | ( |  | ) |

bool hasShadowColor | ( |  | ) |

bool hasSlant | ( |  | ) |

bool hasSmallCaps | ( |  | ) |

bool hasSmallCapsScale | ( |  | ) |

bool hasTabWidth | ( |  | ) |

bool hasTextColor | ( |  | ) |

bool hasTextScale | ( |  | ) |

bool hasUnderscore | ( |  | ) |

bool hasUnderscoreHeight | ( |  | ) |

bool hasWordwrap | ( |  | ) |

bool isAnySpecified | ( |  | ) |

Returns true if any properties have been specified, false otherwise.

bool operator!= | ( | TextProperties const | other | ) |

TextProperties operator= | ( | TextProperties const | copy | ) |

bool operator== | ( | TextProperties const | other | ) |

setAlign | ( | Alignment | align_type | ) |

Specifies the alignment of the text within its margins.

Reimplemented in TextNode.

setBin | ( | string | bin | ) |

Names the CullBin that the text geometry should be assigned to.

If this is set, then a CullBinAttrib will be created to explicitly place each component in the named bin.

The draw_order value will also be passed to each CullBinAttrib as appropriate; this is particularly useful if this names a CullBinFixed, e.g. "fixed".

Reimplemented in TextNode.

static setDefaultFont | ( | TextFont |  | ) | `[static]`

Specifies the default font to be used for any TextNode whose font is uninitialized or NULL.

See set_font().

int setDrawOrder | ( | int | draw_order | ) |

Sets the drawing order of text created by the TextNode.

This is actually the draw order of the card and frame. The shadow is drawn at _draw_order+1, and the text at _draw_order+2.

This affects the sorting order assigned to the nodes as they are created, and also is passed to whatever bin may be assigned via set_bin().

The return value is the first unused draw_order number, e.g. _draw_order + 3.

Reimplemented in TextNode.

setFont | ( | TextFont | font | ) |

Sets the font that will be used when making text.

If this is set to NULL, the default font will be used, which can be set via set_default_font().

Reimplemented in TextNode.

setGlyphScale | ( | float | glyph_scale | ) |

Specifies the factor by which to scale each letter of the text as it is placed, in addition to any scales inherited from the node or from set_text_scale().

This can be used (possibly in conjunction with set_glyph_shift()) to implement superscripting or subscripting.

The glyph scale is cumulative when applied to nested TextProperties. It is intended primarily for implementing superscripts, not for scaling the text in general. See also set_text_scale(), which is intended primarily for scaling the text in general, and is not cumulative.

Reimplemented in TextNode.

setGlyphShift | ( | float | glyph_shift | ) |

Specifies a vertical amount to shift each letter of the text as it is placed.

This can be used (possibly in conjunction with set_glyph_scale()) to implement superscripting or subscripting.

Reimplemented in TextNode.

setIndent | ( | float | indent | ) |

Specifies the amount of extra space that is inserted before the first character of each line.

This can be thought of as a left margin.

Reimplemented in TextNode.

setPreserveTrailingWhitespace | ( | bool | preserve_trailing_whitespace | ) |

Sets the preserve_trailing_whitespace flag.

When this is set, trailing whitespace at the end of the line is not stripped when the text is wordwrapped (it is stripped by default). Since the trailing whitespace is invisible, this is important primarily for determining the proper width of a frame or card behind the text.

setShadow | ( | VBase2 const | shadow_offset | ) |

Specifies that the text should be drawn with a shadow, by creating a second copy of the text and offsetting it slightly behind the first.

Reimplemented in TextNode.

setShadow | ( | float | xoffset,
|  | float | yoffset
| ) |  |

Specifies that the text should be drawn with a shadow, by creating a second copy of the text and offsetting it slightly behind the first.

Reimplemented in TextNode.

setShadowColor | ( | VBase4 const | shadow_color | ) |

Reimplemented in TextNode.

setShadowColor | ( | float | r,
|  | float | g,
|  | float | b,
|  | float | a
| ) |  |

Reimplemented in TextNode.

setSlant | ( | float | slant | ) |

Specifies the factor by which the text slants to the right.

Reimplemented in TextNode.

setSmallCaps | ( | bool | small_caps | ) |

Sets the small_caps flag.

When this is set, lowercase letters are generated as scaled-down versions of their uppercase equivalents. This is particularly useful to set for fonts that do not have lowercase letters.

It is also a good idea to set this for a (dynamic) font that has already implemented lowercase letters as scaled-down versions of their uppercase equivalents, since without this flag the texture memory may needlessly duplicate equivalent glyphs for upper and lowercase letters. Setting this flag causes the texture memory to share the mixed-case letters.

The amount by which the lowercase letters are scaled is specified by set_small_caps_scale().

Reimplemented in TextNode.

setSmallCapsScale | ( | float | small_caps_scale | ) |

Sets the scale factor applied to lowercase letters from their uppercase equivalents, when the small_caps flag is in effect.

See set_small_caps(). Normally, this will be a number less than one.

Reimplemented in TextNode.

setTabWidth | ( | float | tab_width | ) |

Sets the width of each tab stop, in screen units.

A tab character embedded in the text will advance the horizontal position to the next tab stop.

Reimplemented in TextNode.

setTextColor | ( | float | r,
|  | float | g,
|  | float | b,
|  | float | a
| ) |  |

Reimplemented in TextNode.

setTextColor | ( | VBase4 const | text_color | ) |

Reimplemented in TextNode.

setTextScale | ( | float | text_scale | ) |

Specifies the factor by which to scale the text, in addition to any scalings imposed by the node, as well as in addition to the glyph scale.

The text scale is not cumulative when applied to nested TextProperties. See also set_glyph_scale(), which is cumulative.

setUnderscore | ( | bool | underscore | ) |

Sets the underscore flag.

When this is set, the text is underscored with a one-pixel line the same color as the text foreground, drawn at the baseline.

setUnderscoreHeight | ( | float | underscore_height | ) |

Specifies the vertical height of the underscore, relative to the text baseline.

This only has meaning if the underscore mode is enabled with set_underscore().

setWordwrap | ( | float | wordwrap | ) |

Sets the text up to automatically wordwrap when it exceeds the indicated width.

This can be thought of as a right margin or margin width.

Reimplemented in TextNode.

write | ( | ostream | out,
|  | int | indent_level
| ) |  |

Reimplemented in TextNode.

write | ( | ostream | out | ) |

Reimplemented in TextNode.

All Classes Namespaces Functions Variables Enumerations Enumerator Properties